#! /bin/sh

[ -z "$RCCMD_DEFCFG" ] && RCCMD_DEFCFG=rccmd.cfg

if [ -f $RCCMD_DEFCFG ]; then
	 $doecho \\nsave existing `pwd`/$RCCMD_DEFCFG to `pwd`/${RCCMD_DEFCFG}.bkp... \\c
    mv $RCCMD_DEFCFG ${RCCMD_DEFCFG}.bkp || doerror \\nfailed to rename $RCCMD_DEFCFG
    $doecho ok!; sleep 1
fi

$doecho \\nwriting default configuration `pwd`/${RCCMD_DEFCFG}... \\c

cat > $RCCMD_DEFCFG<<EOF
#######################################
# RCCMD Configuration (v2-default)
#######################################

#
# Bind on Interface
# Defines on which interface we listen for incoming commands
# Default: 0.0.0.0 (All possible interfaces on this host)
#
ListenAddress=0.0.0.0

#
# Listen on Port
# Defines on which interface port we listen for incoming commands.
# Default: 6003
#
ListenPort=6003

#
# Enable UDP
# Defines if we should listen for rccmd (UDP) broadcasts
# Default: true
#
ListenUDP=true

#
# Access Control List
# A list of valid sender addresses, only its members can connect to us.
# Seperate IP addresses with a space, e.g.: "192.168.0.1 192.168.0.2".
# Default: <empty> (Everyone is allowed to connect to us)
#
AllowedAddresses=

#######################################
EOF

	 [ $? = 0 ] && chown root:0 $RCCMD_DEFCFG && chmod 774 $RCCMD_DEFCFG
[ $? = 0 ] || doerror failed to write $RCCMD_DEFCFG

$doecho ok!; sleep 1
