# ------------------------------------------------------------
# ask_for_readme()
# ------------------------------------------------------------

ask_for_readme() {
if [ -n "$INFO_DIR" -a -f $INFO_DIR/[Rr][Cc][Cc][Mm][Dd].[Tt][Xx][Tt] ]; then
    RCCMDREADME=`ls $INFO_DIR/[Rr][Cc][Cc][Mm][Dd].[Tt][Xx][Tt] 2>/dev/null`

    $doecho \\nDo you want to read the information for Rccmd tool [Y/n]?: \\c
    read yesno
    dodebug "yesno = >$yesno<"
    if [ "$yesno" = "" ] || [ $yesno = y ] || [ $yesno = Y ]; then
	more $RCCMDREADME; sleep 1
    fi
fi
} # ask_for_readme()

# ------------------------------------------------------------
# do_jrccmdcfg_inst()
# ------------------------------------------------------------
do_jrccmdcfg_inst() {

UHD_WWWDIR="www"
RETURNPATH=`pwd`

if [ -f $OSVER/[Jj][Rr][Cc][Cc][Mm][Dd].[Tt][Aa][Rr] ]; then
    JRCCMD_TAR=`ls $OSVER/[Jj][Rr][Cc][Cc][Mm][Dd].[Tt][Aa][Rr] 2>/dev/null`
else
    doerror can\'t find $OSVER/jrccmd.tar, no such file!
    return 1
fi

[ -d $UHD_WWWDIR ] || mkdir $UHD_WWWDIR
[ -d $UHD_WWWDIR ] || doerror can\'t create subdirectory `pwd`/$UHD_WWWDIR!

chown root:0 $UHD_WWWDIR && chmod 775 $UHD_WWWDIR
[ $? = 0 ] || doerror failed to set permissions for `pwd`/$UHD_WWWDIR

cd $UHD_WWWDIR || doerror can\'t cd to `pwd`/$UHD_WWWDIR

#[ $UPS_DIR = $RETURNPATH ] || doerror $RETURNPATH doesn\'t match

$doecho \\nInstall JAVA RCCMD CONFIG Applet in `pwd`... \\c

[ -n "$JRCCMD_TAR" ] && [ -f "$JRCCMD_TAR" ] && $UNTAR $JRCCMD_TAR 2>&1

[ -f jrccmdcfg.jar ] && chmod 644 jrccmdcfg.jar
[ $? = 0 ] || doerror failed to set permissions for `pwd`/jrccmdcfg.jar

cd $RETURNPATH

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# do_rccmd2_inst()
# ------------------------------------------------------------

do_rccmd2_inst() {

#[ -z "$RCCMD_ARCHIVE" ] && RCCMD_ARCHIVE="rccmd sendups waitups uninstall uninstall.awk"
if [ -n "$WPATH" -a -d $WPATH/[Rr][Cc][Cc][Mm][Dd] ]; then
    RCCMD=`ls -d $WPATH/[Rr][Cc][Cc][Mm][Dd] 2>/dev/null`
else
    doerror can\'t find "$WPATH"/RCCMD, no such directory!
fi

RCCMDBIN_TAR=`ls $RCCMD/[Rr][Cc][Cc][Mm][Dd][Bb][Ii][Nn].[Tt][Aa][Rr] 2>/dev/null`
[ -f $RCCMDBIN_TAR ] || doerror can\'t find $RCCMD/rccmdbin.tar, no such file!

RCCMDSCRIPTS_TAR=`ls $RCCMD/[Rr][Cc][Cc][Mm][Dd][Ss][Hh].[Tt][Aa][Rr] 2>/dev/null`
[ -f $RCCMDSCRIPTS_TAR ] || doerror can\'t find $RCCMD/rccmdsh.tar, no such file!


$doecho \\nInstall Rccmd binaries in `pwd`... \\c
dodebug "RCCMDBIN_TAR = >$RCCMDBIN_TAR<"

tarerror=`$UNTAR $RCCMDBIN_TAR 2>&1`
#[ "$tarerror" ] && doerror \\n$tarerror

chown root:0 $RCCMDAPPS && chmod 770 $RCCMDAPPS
[ $? = 0 ] || doerror failed to fix permissions for binaries

$doecho ok!; sleep 1


$doecho \\nInstall Rccmd scripts in `pwd`... \\c
dodebug "RCCMDSCRIPTS_TAR = >$RCCMDSCRIPTS_TAR<"

tarerror=`$UNTAR $RCCMDSCRIPTS_TAR 2>&1`
#[ "$tarerror" ] && doerror \\n$tarerror

#TMPHOME=`pwd`
for i in `ls send_*.sh` $RCCMD_STARTER; do
    sed -e "/RCCMDHOME:/s|\.|$UPS_DIR|" $i >$i.tmp && mv $i.tmp $i
    [ $? = 0 ] || doerror failed to fix home-path in $i
done

chown root:0 $RCCMDSCRIPTS && chmod 770 $RCCMDSCRIPTS 
[ $? = 0 ] || doerror failed to fix permissions for scripts

$doecho ok!; sleep 1

} # do_rccmd2_inst()

# ------------------------------------------------------------
# do_rccmd_inst()
# ------------------------------------------------------------

do_rccmd_inst() {

#[ -z "$RCCMD_ARCHIVE" ] && RCCMD_ARCHIVE="rccmd sendups waitups uninstall uninstall.awk"
if [ -n "$WPATH" -a -d $WPATH/[Rr][Cc][Cc][Mm][Dd] ]; then
    RCCMD=`ls -d $WPATH/[Rr][Cc][Cc][Mm][Dd] 2>/dev/null`
else
    doerror can\'t find "$WPATH"/RCCMD, no such directory!
fi
[ -f $RCCMD/*.[Tt][Aa][Rr] ] || doerror can\'t find $RCCMD/*.tar, no such file!

RCCMD_TAR=`ls $RCCMD/[Rr][Cc][Cc][Mm][Dd].[Tt][Aa][Rr] 2>/dev/null`

$doecho \\nInstall Rccmd tool in `pwd`... \\c
#dodebug "archive = `tar tf $RCCMD_TAR`"
dodebug "RCCMD_TAR = >$RCCMD_TAR<"

tarerror=`$UNTAR $RCCMD_TAR 2>&1`
#[ "$tarerror" ] && doerror \\n$tarerror

chown root:0 rccmd && chmod 770 rccmd
[ $? = 0 ] || doerror failed to fix permissions for `pwd`/rccmd

[ -f sendups ] && chown root:0 sendups && chmod 770 sendups
[ -f waitups ] && chown root:0 waitups && chmod 770 waitups
#[ -f uninstall ] rm uninstall
#[ -f uninstall.awk ] rm uninstall.awk

$doecho ok!; sleep 1
} # do_rccmd_inst()

# ------------------------------------------------------------
# WriteStartrccmd()
# ------------------------------------------------------------
WriteStartrccmd() {

[ -z "$RCCMD_STARTER" ] && RCCMD_STARTER=startrccmd

if [ -f $RCCMD_STARTER ]; then
    $doecho \\nsave existing `pwd`/$RCCMD_STARTER to `pwd`/${RCCMD_STARTER}.bkp... \\c
    mv $RCCMD_STARTER ${RCCMD_STARTER}.bkp || doerror \\nfailed to rename $RCCMD_STARTER
    $doecho ok!; sleep 1
fi

$doecho \\nwriting startscript `pwd`/${RCCMD_STARTER}... \\c

cat > $RCCMD_STARTER<<EOF
#!/bin/sh
#
#$UPSIDENT

[ -x `pwd`/rccmd ] || exit 0

PATH=/sbin:/usr/sbin:/bin:/usr/bin

# You may specify a sender IP to accept signals from,
# default is everyone.
RCCMDSENDER=

# You may change the port to listen on,
# default is 6003.
RCCMDPORT=

# You may define a command to be executed on
# receive of signal, default is $RCCMDPATH/$COMMANDFILE
RCCMDCMD=

[ -z "\$RCCMDSENDER" ] || RCCMDSENDER="-a \$RCCMDSENDER"
[ -z "\$RCCMDPORT" ] || RCCMDPORT="-p \$RCCMDPORT"
[ -z "\$RCCMDCMD" ] || RCCMDCMD="`pwd`/\$RCCMDCMD"

CURRDIR=\$PWD
cd $UPS_DIR

case "\$1" in
conf)
    echo -n "Starting RCCMD configuration..."
    javabin=java
    javatest=\`\$javabin -cp www/jrccmdcfg.jar com.generex.jrccmdcfg.utils.CheckJavaRuntime  2>&1\`
    if [ "\$javatest" != "ok" ] && [ -d `pwd`/jre1.5.0_12 ]; then
      javabin=./jre1.5.0_12/bin/java
      javatest=\`\$javabin -cp www/jrccmdcfg.jar com.generex.jrccmdcfg.utils.CheckJavaRuntime  2>&1\`
    fi
    if [ "\$javatest" != "ok" ]; then
      echo 'non existing or invalid JAVA Runtime'
      echo \$javatest
      echo 'no configuration with JRCCMDCFG possible'
      [ -x ./rccmd_conf ] && ./rccmd_conf
    else
      \$javabin -cp www/jrccmdcfg.jar com.generex.jrccmdcfg.JRccmdcfg
    fi
    ;;
    
start)
    rccmdpid=\`$ps_prog | awk '\$4 ~ /rccmd/ && \$4 !~ /[0-9][0-9]/ && \$2 ~ /[?|-]|console/ { print \$1 }'\`
    $doecho "starting rccmd listener... \\c"
    if [ ! "\$rccmdpid" ]; then
        `pwd`/rccmd -l \$RCCMDSENDER \$RCCMDPORT \$RCCMDCMD >/dev/null 2>&1
        rccmdpid=\`$ps_prog | awk '\$4 ~ /rccmd/ && \$4 !~ /[0-9][0-9]/ && \$2 ~ /[?|-]|console/ { print \$1 }'\`
        if [ "\$rccmdpid" ]; then
            $doecho "ok!"
        else
            $doecho "failed!"
        fi
    else
        $doecho "allready running."
    fi
    ;;

stop)
    rccmdpid=\`$ps_prog | awk '\$4 ~ /rccmd/ && \$4 !~ /[0-9][0-9]/ && \$2 ~ /[?|-]|console/ { print \$1 }'\`
    $doecho "stopping rccmd listener... \\c"
    if [ "\$rccmdpid" ]; then
        kill \$rccmdpid && $doecho "ok!"
    else
        $doecho "not running."
    fi
    ;;

restart)
    \$0 stop
    \$0 start
    ;;

status)
    rccmdpid=\`$ps_prog | awk '\$4 ~ /rccmd/ && \$4 !~ /[0-9][0-9]/ && \$2 ~ /[?|-]|console/ { print \$1 }'\`
    $doecho "checking rccmd status... \\c"
    if [ "\$rccmdpid" ]; then
        $doecho "running."
    else
        $doecho "not running."
    fi
    ;; 
    
*)
    echo "Usage: \$0 conf|start|stop|restart|status"; exit 1 
    ;;
esac
cd \$CURRDIR
exit 0
EOF

[ $? = 0 ] && chown root:0 $RCCMD_STARTER && chmod 774 $RCCMD_STARTER
[ $? = 0 ] || doerror failed to write $RCCMD_STARTER

$doecho ok!; sleep 1
} # WriteStartrccmd

# ------------------------------------------------------------
# WriteStartrccmdSuSE()
# ------------------------------------------------------------
WriteStartrccmdSuSE() {

[ -z "$RCCMD_STARTER" ] && RCCMD_STARTER=startrccmd

if [ -f $RCCMD_STARTER ]; then
    $doecho \\nsave existing `pwd`/$RCCMD_STARTER to `pwd`/${RCCMD_STARTER}.bkp... \\c
    mv $RCCMD_STARTER ${RCCMD_STARTER}.bkp || doerror \\nfailed to rename $RCCMD_STARTER
    $doecho ok!; sleep 1
fi

$doecho \\nwriting startscript `pwd`/${RCCMD_STARTER}... \\c

cat > $RCCMD_STARTER<<EOF
#!/bin/sh
#
# System startup script for RCCMD service/daemon
#
# /etc/init.d/rccmd 
#
### BEGIN INIT INFO
# Provides:       rccmd
# Required-Start: \$local_fs \$remote_fs \$syslog \$network
# Should-Start:
# Required-Stop:
# Default-Start:   2 3 5
# Default-Stop:    0 1 5
# Description:    Start the RCCMD service
### END INIT INFO

# Check for missing binaries
RCCMD_BIN=`pwd`/rccmd
test -x \$RCCMD_BIN || { echo "\$RCCMD_BIN not installed"; 
	if [ "\$1" = "stop" ]; then exit 0;
	else exit 5; fi; }

# Load the rc.status script.
. /etc/rc.status

# Reset status.
rc_reset

# Set our environment
PATH=/sbin:/usr/sbin:/bin:/usr/bin
i=90
CURRDIR=\$PWD
cd $UPS_DIR

# You may specify a sender IP to accept signals from,
# default is everyone.
RCCMDSENDER=

# You may change the port to listen on,
# default is 6003.
RCCMDPORT=

# You may define a command to be executed on
# receive of signal, default is $RCCMDPATH/$COMMANDFILE
RCCMDCMD=

[ -z "\$RCCMDSENDER" ] || RCCMDSENDER="-a \$RCCMDSENDER"
[ -z "\$RCCMDPORT" ] || RCCMDPORT="-p \$RCCMDPORT"
[ -z "\$RCCMDCMD" ] || RCCMDCMD="`pwd`/\$RCCMDCMD"

case "\$1" in
   conf)
    echo -n "Starting RCCMD configuration..."
    cd `pwd`
    javabin=java
    javatest=\`\$javabin -cp www/jrccmdcfg.jar com.generex.jrccmdcfg.utils.CheckJavaRuntime  2>&1\`
    if [ "\$javatest" != "ok" ] && [ -d `pwd`/jre1.5.0_12 ]; then
      javabin=./jre1.5.0_12/bin/java
      javatest=\`\$javabin -cp www/jrccmdcfg.jar com.generex.jrccmdcfg.utils.CheckJavaRuntime  2>&1\`
    fi
    if [ "\$javatest" != "ok" ]; then
      echo 'non existing or invalid JAVA Runtime'
      echo \$javatest
      echo 'no configuration with JRCCMDCFG possible'
      [ -x ./rccmd_conf ] && ./rccmd_conf
    else
      \$javabin -cp www/jrccmdcfg.jar com.generex.jrccmdcfg.JRccmdcfg
    fi
    ;;
    start)
    echo -n "Starting RCCMD service..."
    cd `pwd`
    # Start service with startproc.
    #startproc \${RCCMD_BIN}
    if [ -z "\$(pidof rccmd)" ]; then
	\$RCCMD_BIN -l \$RCCMDSENDER \$RCCMDPORT \$RCCMDCMD >/dev/null 2>&1
    fi
    # Remember start status
    rc_status -v
    # Waiting for rccmd started
    while [ -z "\$(pidof rccmd)" -a \$i -gt 0 ]; do
    	i=\$((\$i - 1))
        sleep 1
    done
    ;;
    stop)
    echo -n "Stopping RCCMD service..."
    cd `pwd`
    # Stop service with killproc.
    killproc -TERM \${RCCMD_BIN}
    # Remember stop status
    rc_status
    ;;
    restart)
      \$0 stop
      # Waiting for rccmd stopped
      while [ -n "\$(pidof rccmd)" -a \$i -gt 0 ]; do
         i=\$((\$i - 1))
         sleep 1
      done
      \$0 start
      rc_status
   ;;
   status)
      echo -n "Checking RCCMD status..."
      checkproc \$RCCMD_BIN
      rc_status -v 
      ;;
   *)
	echo "Usage: \$0 {conf|start|stop|restart|status}"
	exit 1
	;;
esac
cd \$CURRDIR
rc_exit
EOF

[ $? = 0 ] && chown root:0 $RCCMD_STARTER && chmod 774 $RCCMD_STARTER
[ $? = 0 ] || doerror failed to write $RCCMD_STARTER

$doecho ok!; sleep 1
} # WriteStartrccmdSuSE

# ------------------------------------------------------------
# write_rccmd_init()
# ------------------------------------------------------------

write_rccmd_init() {

[ -z "$RCCMD_INIT" ] && RCCMD_INIT=rccmd

if [ -f $RCCMD_INIT ]; then
    $doecho \\nsave existing `pwd`/$RCCMD_INIT to `pwd`/${RCCMD_INIT}.bkp... \\c
    mv $RCCMD_INIT ${RCCMD_INIT}.bkp || doerror //nfailed to rename $RCCMD_INIT
    $doecho ok!; sleep 1
fi
if [ -f rccmd.rc ]; then
    $doecho \\nsave obsolete `pwd`/rccmd.rc to `pwd`/rccmd.rc.bkp... \\c
    mv rccmd.rc rccmd.rc.bkp || doerror failed to rename rccmd.rc
    $doecho ok!; sleep 1
fi

$doecho \\nmoving $UPS_DIR/$RCCMD_STARTER to `pwd`/${RCCMD_INIT}... \\c

mv $UPS_DIR/$RCCMD_STARTER $RCCMD_INIT
[ $? = 0 ] && chown root:0 $RCCMD_INIT && chmod 774 $RCCMD_INIT
[ $? = 0 ] || doerror failed to write $RCCMD_INIT

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# write_rccmd_symlinks()
# ------------------------------------------------------------
write_rccmd_symlinksSuSE() {
#dodebug "create_symlinksSuSE()"

   $doecho "\\nenable rccmd service... \\c"
   #/sbin/insserv -v $initdir/$RCCMD_INIT
   /sbin/insserv $initdir/$RCCMD_INIT
}

write_rccmd_symlinks() {

for i in `ls -d rc?.d 2>/dev/null`; do
    if [ -d $i ]; then
    cd $i
    for j in `ls [KS]*[0-9]rccmd 2>/dev/null` `ls [KS]*[0-9]rccmd.rc 2>/dev/null`; do
	$doecho \\nremove old symlink `pwd`/$j... \\c
	rm $j || doerror failed to remove $j
	$doecho ok!; sleep 1
    done
    cd ..
    fi
done

for i in $startdirs; do
    if [ -d $i ]; then
	cd $i
	dodebug "found dir `pwd`"
	$doecho "\\ncreate link `pwd`/${startlink}rccmd -> $initdir/$RCCMD_INIT... \\c"
        ln -s $initdir/$RCCMD_INIT ${startlink}rccmd \
	|| doerror failed to create ${startlink}rccmd
	$doecho ok!; sleep 1
	cd ..
    fi
done
for i in $killdirs; do
    if [ -d $i ]; then
	cd $i
	dodebug "found dir `pwd`"
	$doecho "\\ncreate link `pwd`/${killlink}rccmd -> $initdir/$RCCMD_INIT... \\c"
	ln -s $initdir/$RCCMD_INIT ${killlink}rccmd \
	|| doerror failed to create ${killlink}rccmd
	$doecho ok!; sleep 1
	cd ..
    fi
done

}

# ------------------------------------------------------------
# write_startrccmd_link()
# ------------------------------------------------------------

write_startrccmd_link(){

    if [ -f $RCCMD_STARTER ]; then
    $doecho \\nsave existing `pwd`/$RCCMD_STARTER to `pwd`/${RCCMD_STARTER}.bkp... \\c
    mv $RCCMD_STARTER ${RCCMD_STARTER}.bkp || doerror \\nfailed to rename $RCCMD_STARTER
    $doecho ok!; sleep 1
fi

$doecho "\\ncreate link `pwd`/${RCCMD_STARTER} -> $initdir/$RCCMD_INIT... \\c"
ln -s $initdir/$RCCMD_INIT $RCCMD_STARTER \
|| doerror failed to create $RCCMD_STARTER

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# write_rccmd_inittab() # AIX only
# ------------------------------------------------------------

write_rccmd_inittab() {

$doecho \\nDo you want to start rccmd-listener automatically on system boot [Y/n]?: \\c
read yesno

if [ "$yesno" != "" ] && [ $yesno != y ] && [ $yesno != Y ]; then
    return 0
fi

RC2ENTRY_VERYOLD="rccmd:2:once:/usr/ups/rccmd -l /usr/ups/doshutdown   # default entry for rccmd"
RC2ENTRY_OLD="rccmd:2:once:/usr/ups/startrccmd start>/dev/console 2>&1  # default entry for rccmd"
RC2ENTRY="rccmd:2:once:`pwd`/$RCCMD_STARTER start>/dev/console 2>&1  # default entry for rccmd"
#RC0ENTRY="/usr/ups/upsman -s   # default entry for upsman"

STATE=`lsitab "rccmd"`

if [ -z "$STATE" ]; then
    $doecho "creating default entry in /etc/inittab"
    mkitab "$RC2ENTRY" || doerror failed to write to /etc/inittab
elif [ "$STATE" = "$RC2ENTRY_VERYOLD" ]; then
    $doecho "changing old entry in /etc/inittab"
    chitab "$RC2ENTRY" || doerror failed to write to /etc/inittab
elif [ "$STATE" = "$RC2ENTRY_OLD" ]; then
    $doecho "changing old entry in /etc/inittab"
    chitab "$RC2ENTRY" || doerror failed to write to /etc/inittab
elif [ "$STATE" = "$RC2ENTRY" ]; then
    $doecho "using default entry in /etc/inittab"
#elif [ `echo $STATE | grep "# default entry for rccmd"` ]; then
#    $doecho "changing old entry in /etc/inittab"
#    chitab "$RC2ENTRY" || doerror failed to write to /etc/inittab
else
    $doecho \\nYou seem to have a customized entry for rccmd in your /etc/inittab\;
    $doecho \"$STATE\"
    $doecho \\ndo you want to replace it for the current installation [Y/n]?: \\c
    read yesno

    if [ X"$yesno" = X ] || [ X"$yesno" = Xy ] || [ X"$yesno" = XY ]; then
	$doecho "updating /etc/inittab"
	chitab "$RC2ENTRY" || doerror failed to write to /etc/inittab
    fi

fi

sleep 1
}

# ------------------------------------------------------------
# write_mac_startup() # mac only
# ------------------------------------------------------------

write_mac_startup() {

MACINITDIR=/System/Library/StartupItems
MACRCCMDINITDIR=$MACINITDIR/Rccmd
MACRCCMDINITSCRIPT=$MACRCCMDINITDIR/rccmd
MACRCCMDINITPARAMS=$MACRCCMDINITDIR/StartupParameters.plist

$doecho \\nDo you want to start rccmd-listener automatically on system boot [Y/n]?: \\c
read yesno

if [ "$yesno" != "" ] && [ $yesno != y ] && [ $yesno != Y ]; then
    return 0
fi

[ -d $MACINITDIR ] || doerror could not find $MACINITDIR, no such directory!

if [ ! -d $MACRCCMDINITDIR ]; then
    $doecho \\ncreating subdir $MACRCCMDINITDIR... \\c
    mkdir $MACRCCMDINITDIR || doerror //n could not create $MACRCCMDINITDIR
    $doecho ok!; sleep 1
fi

$doecho \\nwriting init script $MACRCCMDINITSCRIPT... \\c

cat > $MACRCCMDINITSCRIPT<<EOF
#!/bin/sh

. /etc/rc.common

##
# launch rccmd listener
##

if [ -x $UPS_DIR/$RCCMD_STARTER ]; then

    $UPS_DIR/$RCCMD_STARTER start
fi
EOF

[ $? = 0 ] && chown root:0 $MACRCCMDINITSCRIPT && chmod 774 $MACRCCMDINITSCRIPT
[ $? = 0 ] || doerror failed to write $MACRCCMDINITSCRIPT

$doecho ok!; sleep 1

$doecho \\nwriting init script $MACRCCMDINITPARAMS... \\c

cat > $MACRCCMDINITPARAMS<<EOF
{
  Description     = "remote command execution";
  Provides        = ("Rccmd");
  Requires        = ("Resolver");
  OrderPreference = "None";
  Messages =
  {
    start = "Starting rccmd listener";
    stop  = "Stopping rccmd listener";
  };
}
EOF

[ $? = 0 ] && chown root:0 $MACRCCMDINITPARAMS && chmod 664 $MACRCCMDINITPARAMS
[ $? = 0 ] || doerror failed to write $MACRCCMDINITPARAMS

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# writeDefRccmdCfg()
# ------------------------------------------------------------
writeDefRccmdCfg()
{
[ -z "$RCCMD_DEFCFG" ] && RCCMD_DEFCFG=rccmd.cfg

if [ -f $RCCMD_DEFCFG ]; then
	 $doecho \\nsave existing `pwd`/$RCCMD_DEFCFG to `pwd`/${RCCMD_DEFCFG}.bkp... \\c
    mv $RCCMD_DEFCFG ${RCCMD_DEFCFG}.bkp || doerror \\nfailed to rename $RCCMD_DEFCFG
    $doecho ok!; sleep 1
fi

$doecho \\nwriting default configuration `pwd`/${RCCMD_DEFCFG}... \\c

cat > $RCCMD_DEFCFG<<EOF
#######################################
# RCCMD Configuration (v3-default)
#######################################

#
# License Key
#
Key=$key

#
# Bind on Interface
# Defines on which interface we listen for incoming commands
# Default: 0.0.0.0 (All possible interfaces on this host)
#
ListenAddress=0.0.0.0

#
# Listen on Port
# Defines on which interface port we listen for incoming commands.
# Default: 6003
#
ListenPort=6003

#
# Enable UDP
# Defines if we should listen for rccmd (UDP) broadcasts
# Default: true
#
ListenUDP=true

#
# Access Control List
# A list of valid sender addresses, only its members can connect to us.
# Seperate IP addresses with a space, e.g.: "192.168.0.1 192.168.0.2".
# Default: <empty> (Everyone is allowed to connect to us)
#
AllowedAddresses=

#######################################
# Alive Check
#
# Enable Alive Check
# Defines if we should perform UPSMan alive checking.
# Default: false
#
AliveEnabled=false

#
# Alive Check Rate
# Defines the interval of UPSMan alive checking, in seconds.
# Default: 1800
#
AliveInterval=1800

#
# Alive Retry Rate
# Defines the number of UPSMan alive checking retries, in case of problems.
# Default: 0
#
AliveRetries=5

#
# Alive Check Group Members List
# A list of UPS device addresses that should be checked periodically.
# Seperate IP addresses with a space, e.g.: "192.168.0.1 192.168.0.2".
# Default: <empty> (No alive checking)
#
AliveAddresses=

#
# Alive Program
# Full path to script that is executed when an alive check fails.
# Default: rccmd_notalive.sh
#
AliveProg=

#######################################
# Redundacy Mode
#
# Enable Redundancy
# Defines if we should operate in redundancy mode.
# Requires an enabled <Alive Check> configuration.
# Default: false
#
RedundancyEnabled=false

#
# Redundancy Group Members List
# A list of redundancy group member addresses, must be also in <AliveAddresses>.
# Seperate IP addresses with a space, e.g.: "192.168.0.1 192.168.0.2".
# Default: <empty> (No redundancy available)
#
RedundancyAddresses=

#
# Redundancy Level
# Defines how many of the <RedundancyAddresses> are redundant.
# Shutdown is executed when the number of shutdown requests exceeds this number.
# Default: 0 (No redundancy available)
#
RedundancyLevel=0

# Enable Redundancy Script
# Defines if we should NOT execute a script when redundancy suppresses a shutdown.
# Default: false.
#
RedundancyBatchSuppress=false

# Redundancy Script
# Full path to script that is executed when redundancy suppresses a shutdown.
# Default: ShutdownSuppressed.sh
#
RedundancyBatchFile=rccmd_redundancy.sh

#######################################
EOF

[ $? = 0 ] && chown root:0 $RCCMD_DEFCFG && chmod 774 $RCCMD_DEFCFG
[ $? = 0 ] || doerror failed to write $RCCMD_DEFCFG

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# InstallRccmd()
# ------------------------------------------------------------

InstallRccmd()
{
[ -z "$UNTAR" ] && UNTAR="tar xf"
[ -z "$RCCMD_INIT" ] && RCCMD_INIT=rccmd
if [ X${OPSYS} = XQNX ]; then
[ -z "$RCCMDAPPS" ] && RCCMDAPPS=rccmd
[ -z "$RCCMDSCRIPTS" ] &&  RCCMDSCRIPTS="
	rccmd_execute.sh rccmd_mail.sh rccmd_message.sh rccmd_notalive.sh rccmd_shutdown.sh
	send_checkupsman.sh send_log.sh send_mail.sh send_message.sh send_shutdown.sh"
else
    if [ X${OPSYS} = XLINUX_X86 ]; then
    [ -z "$RCCMD_STARTER" ] && RCCMD_STARTER=rccmdctl
    [ -z "$RCCMDAPPS" ] && RCCMDAPPS="rccmd rccmd_conf"
    [ -z "$RCCMDSCRIPTS" ] &&  RCCMDSCRIPTS="rccmdctl
    	rccmd_execute.sh rccmd_mail.sh rccmd_message.sh rccmd_notalive.sh rccmd_shutdown.sh
    	send_checkupsman.sh send_log.sh send_mail.sh send_message.sh send_shutdown.sh rccmd_redundancy.sh"
    else
    [ -z "$RCCMD_STARTER" ] && RCCMD_STARTER=rccmdctl
    [ -z "$RCCMDAPPS" ] && RCCMDAPPS="rccmd rccmd_conf"
    [ -z "$RCCMDSCRIPTS" ] &&  RCCMDSCRIPTS="rccmdctl
        rccmd_execute.sh rccmd_mail.sh rccmd_message.sh rccmd_notalive.sh rccmd_shutdown.sh
        send_checkupsman.sh send_log.sh send_mail.sh send_message.sh send_shutdown.sh"
    fi
fi

ask_for_readme

$doecho \\nInstall Rccmd to $UPS_DIR,
#$doecho \\nInstall Rccmd for $OPSYS to $UPS_DIR,
$doecho directories will be created as needed [Y/n]?: \\c
read yesno

if [ "$yesno" != "" ] && [ $yesno != y ] && [ $yesno != Y ]; then
    sleep 1
    doexit \\nInstallation aborted!
fi

#check_ups_dir
check_dir_path $UPS_DIR

cd ${UPS_DIR}

do_rccmd2_inst

#WriteShutdownCommand

do_messages_inst

if [ X${OPSYS} = XQNX ]; then
	 . ${PARTINSTALL_DIR}/QNX/WriteStartrccmd.sh
else
   if [ X${OPSYS} = XLINUX_X86 ]; then
	   WriteStartrccmd
	elif [ X${OPSYS} = XLINUX_PPC ]; then
	   WriteStartrccmd
	elif [ X${OPSYS} = XLINUX_ALPHA ]; then
	   WriteStartrccmd
	else
	   if [ X${OPSYS} = XIBMAIX51 ]; then
	      WriteStartrccmd
	   elif [ X${OPSYS} = XSCO_UNIX ]; then
	      WriteStartrccmd
	   else
         if [ X${OPSYS} = XSUNSOL7.SPC ]; then
	         WriteStartrccmd
	      else
	         if [ X${OPSYS} = XSUNSOL8.X86 ]; then
	            WriteStartrccmd
	         fi
	      fi
	   fi
	fi
	# All other OS using the script delivered thru rccmdsh.tar.
fi

if [ X${OPSYS} = XQNX ]; then
	. ${PARTINSTALL_DIR}/QNX/WriteDefRccmdCfg.sh
else
	 writeDefRccmdCfg
fi

do_jrccmdcfg_inst

if [ X${OPSYS} = XIBMAIX51 ] || [ X${OPSYS} = XBSD_X86 ] || [ X${OPSYS} = XQNX ]; then
	 $doecho "\\nTo configure rccmd, please edit $(pwd)/rccmd.cfg"
else
	 $doecho "\\nThis is NOT an ITANIUM (IA-64) system [Y/n]?: \\c"
	 read yesno

	 if [ "$yesno" = "" ] || [ $yesno = y ] || [ $yesno = Y ]; then
		  $doecho \\nDo you want to configure rccmd now [Y/n]?: \\c
		  read yesno

		  if [ "$yesno" = "" ] || [ $yesno = y ] || [ $yesno = Y ]; then
				./$RCCMD_STARTER conf
				$doecho \\nTo reconfigure rccmd enter: \"`pwd`/$RCCMD_STARTER conf\"
		  else
				$doecho "\\nTo configure rccmd, please edit $(pwd)/rccmd.cfg"
		  fi  
	 else
	   $doecho "\\nTo configure rccmd, please edit $(pwd)/rccmd.cfg"
	 fi
fi

sleep 1

# shall we start RCCMD listener on system boot ?

#if [ ${OPSYS} = [Bb][Ss][Dd][_][Xx][8][6] ]; then
case $OPSYS in
#if [ $OPSYS = BSD_X86 -o $OPSYS = bsd_x86 ]; then
    [Bb][Ss][Dd]*)
	$doecho \\nTo start rccmd automatically at system boot add the command
	$doecho `pwd`/$RCCMD_STARTER start
	$doecho to your /etc/rc bootscript
	$doecho \\nTo stop rccmd automatically at system shutdown add the command
	$doecho `pwd`/$RCCMD_STARTER stop
	$doecho to your /etc/rc.shutdown script
    ;;
#elif [ ${OPSYS} = [Ii][Bb][Mm][Aa][Ii][Xx] ]; then
    [Ii][Bb][Mm][Aa][Ii][Xx]*)
#elif [ $OPSYS = IBMAIX43 -o $OPSYS = ibmaix43 ]; then
	write_rccmd_inittab
    ;;
    [Mm][Aa][Cc][Ii][Nn][Tt][Oo][Ss][Hh])
#elif [ $OPSYS = MACINTOSH -o $OPSYS = macintosh ]; then
	write_mac_startup
    ;;
    [Qq][Nn][Xx]*)
	$doecho "\\nTo start rccmd automatically at system boot add the command"
	$doecho "$(pwd)/$RCCMD_STARTER start"
	$doecho "to your /etc/config/sysinit[.<node>] bootscript"
    ;;

    *)
#else
    [ -z "$initdir" ] && find_initdir
    dodebug "initdir = >$initdir<"
    [ -z "$rc_parent" ] && find_rcparent
    dodebug "rc_parent= >$rc_parent<"

    if [ -n $initdir -a -n $rc_parent ]; then
	$doecho \\nDo you want to start rccmd-listener automatically on system boot [Y/n]?: \\c
	read yesno
	if [ "$yesno" = "" ] || [ $yesno = y ] || [ $yesno = Y ]; then
	    sleep 1
	    savedir=`pwd`
	    cd $initdir
	    write_rccmd_init
	    cd $rc_parent
		write_rccmd_symlinks
	    cd $savedir
	    write_startrccmd_link
	fi
    fi
    ;;
esac
#fi

$doecho \\nRccmd tool installed in directory `pwd`; sleep 1
}

# ------------------------------------------------------------
# ConfigureRccmdScripts()
# ------------------------------------------------------------

ConfigureRccmdScripts() {

if check_for_prog wall; then

cat<<EOF


found "$TMPOUT" on this System;
By default rccmd will print the messages it receives from the network 
to /dev/console. "$TMPOUT" may be used to write these messages to every 
connected terminal. I can edit "rccmd_message.sh" and "rccmd_notalive.sh"
to enable this feature.
If you change your mind later you may edit these files manually, to enable
this feature change the line "TRY_WALL=FALSE" to "TRY_WALL=TRUE".
EOF

    $doecho \\nDo you want to enable messages via $TMPOUT [Y/n]?: \\c
    read yesno

    if [ X"$yesno" = X ] || [ X"$yesno" = Xy ] || [ X"$yesno" = XY ]; then

    sed -e "/WALL=wall/s|wall|$TMPOUT|; \
	    /TRY_WALL=/s|FALSE|TRUE|" rccmd_message.sh >rccmd_message.sh.tmp \
    && mv rccmd_message.sh.tmp rccmd_message.sh
    [ $? = 0 ] || doerror failed to configure rccmd_message.sh

    sed -e "/WALL=wall/s|wall|$TMPOUT|; \
	    /TRY_WALL=/s|FALSE|TRUE|" rccmd_notalive.sh >rccmd_notalive.sh.tmp \
    && mv rccmd_notalive.sh.tmp rccmd_notalive.sh
    [ $? = 0 ] || doerror failed to configure rccmd_notalive.sh

    if [ X${OPSYS} = XLINUX_X86 ]; then
    sed -e "/WALL=wall/s|wall|$TMPOUT|; \
        /TRY_WALL=/s|FALSE|TRUE|" rccmd_redundancy.sh >rccmd_redundancy.sh.tmp \
    && mv rccmd_redundancy.sh.tmp rccmd_redundancy.sh
    [ $? = 0 ] || doerror failed to configure rccmd_redundancy.sh
    fi
    fi

    sleep 1;
fi

if check_for_prog logger; then

cat<<EOF


found "$TMPOUT" on this System; 
"$TMPOUT" may be used to log messages rccmd receives from the network 
to the local syslog. I can edit "rccmd_message.sh" and "rccmd_notalive.sh"
to enable this feature.
If you change your mind later you may edit these files manually, to enable
this feature change the line "TRY_LOGGER=FALSE" to "TRY_LOGGER=TRUE".
EOF

    $doecho \\nDo you want to enable logging of network messages to syslog [Y/n]?: \\c
    read yesno

    if [ X"$yesno" = X ] || [ X"$yesno" = Xy ] || [ X"$yesno" = XY ]; then

    sed -e "/LOGGER=logger/s|logger|$TMPOUT|; \
	    /TRY_LOGGER=/s|FALSE|TRUE|" rccmd_message.sh >rccmd_message.sh.tmp \
    && mv rccmd_message.sh.tmp rccmd_message.sh
    [ $? = 0 ] || doerror failed to configure rccmd_message.sh

    sed -e "/LOGGER=logger/s|logger|$TMPOUT|; \
	    /TRY_LOGGER=/s|FALSE|TRUE|" rccmd_notalive.sh >rccmd_notalive.sh.tmp \
    && mv rccmd_notalive.sh.tmp rccmd_notalive.sh
    [ $? = 0 ] || doerror failed to configure rccmd_notalive.sh

    if [ X${OPSYS} = XLINUX_X86 ]; then
    sed -e "/LOGGER=logger/s|logger|$TMPOUT|; \
        /TRY_LOGGER=/s|FALSE|TRUE|" rccmd_redundancy.sh >rccmd_redundancy.sh.tmp \
    && mv rccmd_redundancy.sh.tmp rccmd_redundancy.sh
    [ $? = 0 ] || doerror failed to configure rccmd_redundancy.sh
    fi
    fi

    sleep 1;
fi

XMESSAGE=`ls xmessage 2>/dev/null`
[ $? = 0 ] || XMESSAGE=

if [ X"$XMESSAGE" = X ]; then
    if check_for_prog xmessage; then
	XMESSAGE=$TMPOUT
    fi
else
   XMESSAGE=$UPS_DIR/$XMESSAGE
fi

if [ X"$XMESSAGE" != X ]; then

cat<<EOF


found "$XMESSAGE" on this System;
"$XMESSAGE" may be used to pop up messages rccmd receives from the network 
to a graphical display. I can edit "rccmd_message.sh" and "rccmd_notalive.sh"
to enable this feature.
If you change your mind later you may edit these files manually, to enable
this feature change the line "TRY_XMESSAGE=FALSE" to "TRY_XMESSAGE=TRUE".
EOF

    $doecho \\nDo you want to enable graphical popup messages [Y/n]?: \\c
    read yesno

    if [ X"$yesno" = X ] || [ X"$yesno" = Xy ] || [ X"$yesno" = XY ]; then

	sed -e "/XMESSAGE=xmessage/s|xmessage|$XMESSAGE|; \
		/TRY_XMESSAGE=/s|FALSE|TRUE|" rccmd_message.sh >rccmd_message.sh.tmp \
	&& mv rccmd_message.sh.tmp rccmd_message.sh
	[ $? = 0 ] || doerror failed to configure rccmd_message.sh

	sed -e "/XMESSAGE=xmessage/s|xmessage|$XMESSAGE|; \
		/TRY_XMESSAGE=/s|FALSE|TRUE|" rccmd_notalive.sh >rccmd_notalive.sh.tmp \
	&& mv rccmd_notalive.sh.tmp rccmd_notalive.sh
	[ $? = 0 ] || doerror failed to configure rccmd_notalive.sh
    
    if [ X${OPSYS} = XLINUX_X86 ]; then
    sed -e "/XMESSAGE=xmessage/s|xmessage|$XMESSAGE|; \
        /TRY_XMESSAGE=/s|FALSE|TRUE|" rccmd_redundancy.sh >rccmd_redundancy.sh.tmp \
    && mv rccmd_redundancy.sh.tmp rccmd_redundancy.sh
    [ $? = 0 ] || doerror failed to configure rccmd_redundancy.sh
    fi
	sleep 1;

	XMESSAGE_STATIC=`ls xmessage-static 2>/dev/null`
	[ $? = 0 ] || XMESSAGE_STATIC=
	
	if [ X"$XMESSAGE_STATIC" != X ]; then

cat<<EOF


"$XMESSAGE_STATIC" has been installed with rccmd. 
"$XMESSAGE_STATIC" is statically linked against the X libraries, if you
have problems running "$XMESSAGE" complaining about missing libraries you may
want to try "$XMESSAGE_STATIC" instead, otherwise you can savely delete it.

To use "$XMESSAGE_STATIC" please edit "rccmd_message.sh" and "rccmd_notalive.sh",
change the line "XMESSAGE=$XMESSAGE" to 
"XMESSAGE=$UPS_DIR/$XMESSAGE_STATIC".
EOF
	    
	    sleep 1;
	fi
    fi
fi

chown root:0 $RCCMDSCRIPTS && chmod 774 $RCCMDSCRIPTS 
[ $? = 0 ] || doerror failed to fix permissions for scripts
}

# ------------------------------------------------------------
# StartRccmd()
# ------------------------------------------------------------

StartRccmd() {

$doecho \\n\\nDo you want to start rccmd-listener now [Y/n]?: \\c
read yesno
if [ "$yesno" = "" ] || [ $yesno = y ] || [ $yesno = Y ]; then
	    $doecho; ./$RCCMD_STARTER stop 
	    $doecho; ./$RCCMD_STARTER start
else
	    $doecho \\nTo start rccmd-listener manually enter: \"`pwd`/$RCCMD_STARTER start\"
fi
    
sleep 1
}
